import * as actual from 'next/dist/client/components/navigation';
export * from 'next/dist/client/components/navigation';
import { Mock } from 'storybook/test';

/**
 * Creates a next/navigation router API mock. Used internally.
 *
 * @ignore
 * @internal
 */
declare const createNavigation: (overrides: any) => {
    push: Mock;
    replace: Mock;
    forward: Mock;
    back: Mock;
    prefetch: Mock;
    refresh: Mock;
};
declare const getRouter: () => {
    push: Mock;
    replace: Mock;
    forward: Mock;
    back: Mock;
    prefetch: Mock;
    refresh: Mock;
};

declare const redirect: Mock<(url: string, type?: actual.RedirectType) => never>;
declare const permanentRedirect: Mock<(url: string, type?: actual.RedirectType) => never>;
declare const useSearchParams: Mock<typeof actual.useSearchParams>;
declare const usePathname: Mock<typeof actual.usePathname>;
declare const useSelectedLayoutSegment: Mock<typeof actual.useSelectedLayoutSegment>;
declare const useSelectedLayoutSegments: Mock<typeof actual.useSelectedLayoutSegments>;
declare const useRouter: Mock<typeof actual.useRouter>;
declare const useServerInsertedHTML: Mock<typeof actual.useServerInsertedHTML>;
declare const notFound: Mock<typeof actual.notFound>;
interface Params {
    [key: string]: string | string[];
}
declare const useParams: Mock<() => Params>;

export { createNavigation, getRouter, notFound, permanentRedirect, redirect, useParams, usePathname, useRouter, useSearchParams, useSelectedLayoutSegment, useSelectedLayoutSegments, useServerInsertedHTML };
